/**
  ******************************************************************************
  * @file    Project/PT32x007x_StdPeriph_Templates/PT32x007x_it.c 
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2024/2/28
  * @brief   Main Interrupt Service Routines.
  *          This file provides template for all exceptions handler and 
  *          peripherals interrupt service routine.
  ******************************************************************************
  * @attention
  *
  * 
  *
  * 
  * 
  * 
  *
  *       
  *
  * 
  * 
  *
  * 
  * 
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "PT32x007x_it.h"



/** @addtogroup Template_Project
  * @{
  */

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/******************************************************************************/
/*            Cortex-M0 Processor Exceptions Handlers                         */
/******************************************************************************/

/**
  * @brief  This function handles NMI exception.
  * @param  None
  * @retval None
  */
void NMI_Handler(void)
{

}

/**
  * @brief  This function handles Hard Fault exception.
  * @param  None
  * @retval None
  */
void HardFault_Handler(void)
{
  /* Go to infinite loop when Hard Fault exception occurs */
}

/**
  * @brief  This function handles SVCall exception.
  * @param  None
  * @retval None
  */
void SVC_Handler(void)
{
}

/**
  * @brief  This function handles PendSVC exception.
  * @param  None
  * @retval None
  */
void PendSV_Handler(void)
{
}

/**
* @brief SysTickжϷ
* @param None
* @retval None
*/
void SysTick_Handler(void)
{
}

/******************************************************************************/
/*                 PT32x007x Peripherals Interrupt Handlers                   */
/*  Add here the Interrupt Handler for the used peripheral(s), for the  */
/*  available peripheral interrupt handler's name please refer to the startup */
/*  file (startup_PT32X007x.s).                                            */
/******************************************************************************/

/**
  * @brief  This function handles FLASH interrupt.
  * @param  None
  * @retval None
  */
void IFMC_Handler(void)
{
}

/**
  * @brief  This function handles PA interrupt.
  * @param  None
  * @retval None
  */
void EXTIA_Handler(void)
{
	/*жϱʶ*/	
}

/**
  * @brief  This function handles PB interrupt.
  * @param  None
  * @retval None
  */
void EXTIB_Handler(void)
{

}

/**
  * @brief  This function handles PC interrupt.
  * @param  None
  * @retval None
  */
void EXTIC_Handler(void)
{

}

/**
  * @brief  This function handles PD interrupt.
  * @param  None
  * @retval None
  */
void EXTID_Handler(void)
{

}
/**
  * @brief  This function handles ADC interrupt.
  * @param  None
  * @retval None
  */
void ADC_Handler(void)
{
}


/**
  * @brief  This function handles TIM1 interrupt.
  * @param  None
  * @retval None
  */

void TIM1_Handler(void)
{

}

/**
  * @brief  This function handles TIM2 interrupt.
  * @param  None
  * @retval None
  */
void TIM2_Handler(void)
{

}

/**
  * @brief  This function handles TIM3 interrupt.
  * @param  None
  * @retval None
  */
void TIM3_Handler(void)
{

}

/**
  * @brief  This function handles TIM4 interrupt.
  * @param  None
  * @retval None
  */
void TIM4_Handler(void)
{
}

/**
  * @brief  This function handles SPI interrupt.
  * @param  None
  * @retval None
  */
void SPI_Handler(void)
{
}


/**
  * @brief  This function handles UART0 interrupt.
  * @param  None
  * @retval None
  */
void UART0_Handler(void)
{
	
}


/**
  * @brief  This function handles UART1 interrupt.
  * @param  None
  * @retval None
  */
void UART1_Handler(void)
{
	
}


/**
  * @brief  This function handles I2C interrupt.
  * @param  None
  * @retval None
  */
void I2C_Handler(void)
{

}


/**
  * @brief  This function handles PVD interrupt.
  * @param  None
  * @retval None
  */
void PVD_Handler(void)
{

}


/**
  * @brief  This function handles LPVD interrupt.
  * @param  None
  * @retval None
  */
void LPVD_Handler(void)
{

}





/**
  * @}
  */

/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
