/**
  ******************************************************************************
  * @file    PT32x007x_conf.h
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2024/2/28
  * @brief   
  *          
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __PT32X007X_CONF_H
#define __PT32X007X_CONF_H


#define RETARGET_UART0      1
#define RETARGET_UART1      2
#define RETARGET_UART2      3
#define RETARGET_UART3      4

#define RETARGET_PORT        1

#if (RETARGET_PORT == RETARGET_UART0)
  #define RETARGET_UART_PORT       UART0
  #define RETARGET_COM_PORT        COM1
	#define RETARGET_UART_IRQn       UART0_IRQn
#elif (RETARGET_PORT == RETARGET_UART1)
  #define RETARGET_UART_PORT       UART1
  #define RETARGET_COM_PORT         COM2
	#define RETARGET_UART_IRQn       UART1_IRQn
#elif (RETARGET_PORT == RETARGET_UART2)
  #define RETARGET_UART_PORT       UART2
  #define RETARGET_COM_PORT         COM3
#elif (RETARGET_PORT == RETARGET_UART3)
  #define RETARGET_UART_PORT       UART3
  #define RETARGET_COM_PORT         COM4
#endif

/* Includes ------------------------------------------------------------------*/
/* Comment the line below to disable peripheral header file inclusion */
#include "PT32x007x_adc.h"
#include "PT32x007x_crc.h"
#include "PT32x007x_exti.h"
#include "PT32x007x_gpio.h"
#include "PT32x007x_i2c.h"
#include "PT32x007x_id.h"
#include "PT32x007x_ifmc.h"
#include "PT32x007x_nvic.h"
#include "PT32x007x_pwm.h"
#include "PT32x007x_pwr.h"
#include "PT32x007x_rcc.h"
#include "PT32x007x_spi.h"
#include "PT32x007x_sys.h"
#include "PT32x007x_tim.h"
#include "PT32x007x_uart.h"
#include "PT32x007x_wdg.h"
/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Uncomment the line below to expanse the "assert_param" macro in the 
   Standard Peripheral Library drivers code */
//#define USE_FULL_ASSERT    1 

/* Exported macro ------------------------------------------------------------*/
#ifdef  USE_FULL_ASSERT

/**
  * @brief  The assert_param macro is used for function's parameters check.
  * @param  expr: If expr is false, it calls assert_failed function which reports 
  *         the name of the source file and the source line number of the call 
  *         that failed. If expr is true, it returns no value.
  * @retval None
  */
  #define assert_param(expr) ((expr) ? (void)0 : assert_failed((u8 *)__FILE__, __LINE__))
/* Exported functions ------------------------------------------------------- */
  void assert_failed(u8* file, u32 line);
#else
  #define assert_param(expr) ((void)0)
#endif /* USE_FULL_ASSERT */

#endif /* __PT32x007x_CONF_H */

/************************ (C) COPYRIGHT PENGPAI Microelectronics *****END OF FILE****/
