/******************************************************************************
  * @Example PWM Input Capture
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2024/2/28
  * @brief   ʹø߼ʱTIM1벶
	*					 ԴTIM2ͨʱƵIOתϢ
	*					 ĸߵ͵ƽʱ佫ͨ
	*					 Ϣ9600ʣ8λλ1λֹͣλżУ
  *          
  ******************************************************************************
  * @attention	
	* ʹʱ轫PD4ԴPC6TIM1 CH1Դ̽
	* 󲶻1Mhz * 0xFFFF=65.536ms
	* 
	*ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣 
  * ̼/ͻʹаıϢκ,
  * Pai-ICκֱӣ ӻ̷𺦸
  * 
  * (C) ȨPai-IC Microelectronics  
  *****************************************************************************/
#include "PT32x007x.h"


void Software_Delay(void)//ʱ
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		

*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_5, AFIO_AF_0,ENABLE);	//PD5 TX0
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_6, AFIO_AF_0,ENABLE);	//PD6 RX0
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLengthAndParity = UART_WordLengthAndParity_8D;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_ParityMode_Even;
	UART_InitStruct.UART_Receiver=UART_Receiver_Enable;
	UART_InitStruct.UART_LoopbackMode=UART_LoopbackMode_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/*******************************************************************************
*Function:	UART_Driver
*Description:	UARTģ
*Input:		
*Return:		
*Others:
*******************************************************************************/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}
/*******************************************************************************
*Function:	TIMER_GPIO_Config
*Description:	TIMER
*Input:		
*Return:		
*Others:
			úʹTIMERģ
*******************************************************************************/
void Advanced_TIMER_GPIO_Config(void)
{
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_6, AFIO_AF_2,ENABLE);	//PC6 TIM1_CH1
}

/*******************************************************************************
*Function:	TIMER_Mode_Config
*Description:	TIMER
*Input:		
*Return:		
*Others:
			úʼTIMERģĹ乤ʽ
*******************************************************************************/
void Advanced_TIMER_Mode_Config(void)
{
	PWM_TimeBaseInitTypeDef  TimeBaseInit;
	PWM_ICInitTypeDef CaptureInit;
	PWM_OCInitTypeDef OutInit;		
	NVIC_InitTypeDef NVIC_InitStruct;
	
	/* PWMΪĬϵĹر */	
	PWM_OCStructInit(&OutInit);
	
	PWM_OCInit(TIM1, &OutInit);
	
	/*NVIC*/
	NVIC_InitStruct.NVIC_IRQChannel = TIM1_IRQn;		//ж
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;		//Ƿʹж
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;		//жȼ
	NVIC_Init(&NVIC_InitStruct);						//ʼNVIC

	PWM_ITConfig(TIM1,PWM_IT_IC1I,ENABLE);
	
	TimeBaseInit.PWM_AutoReloadValue = 0xFFFF;	  //󲶻1Mhz * 0xFFFF=65.536ms
	TimeBaseInit.PWM_Prescaler = 64-1;		//64MHZ/64=1MHZ
	TimeBaseInit.PWM_InternalClockSource=PWM_InternalClockSource_SYSCLK;
	
	TimeBaseInit.PWM_Direction = PWM_Direction_Up;	//ϼ
	TimeBaseInit.PWM_CenterAlignedMode = DISABLE;	//򲻱
	PWM_TimeBaseInit(TIM1, &TimeBaseInit);
	
	//غ½ز,ʱ
	CaptureInit.PWM_Channel=PWM_Channel_1;
	CaptureInit.PWM_ICFallCapture=PWM_ICFallCapture_Enable;
	CaptureInit.PWM_ICResetCounter=PWM_ICResetCounter_Enable;
	CaptureInit.PWM_ICRiseCapture=PWM_ICRiseCapture_Enable;
	CaptureInit.PWM_ICSource=PWM_ICSource_ICS1;
	PWM_ICInit(TIM1,&CaptureInit);
	
	PWM_Cmd(TIM1, ENABLE);		//ʹܶʱ
}

void TIM_GPIO_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;				//һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;			//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		//ģʽΪͨ
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_NoPull;	//ƫ
	GPIO_Init(GPIOD, &GPIO_InitStructure);				//ÿ⺯ʼGPIO
		
  GPIO_ResetBits(GPIOD, GPIO_Pin_4);					//GPIO״̬
}
/**
* @brief ʼTIM2
* @param 
* @retval 
*/
void General_TIMER2_Config(void)
{
	TIM_TimeBaseInitTypeDef TimeBaseInit;
	NVIC_InitTypeDef NVIC_InitStruct;
	
	/*NVIC*/
	NVIC_InitStruct.NVIC_IRQChannel = TIM2_IRQn;		//ж
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;		//Ƿʹж
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x01;		//жȼ
	NVIC_Init(&NVIC_InitStruct);						//ʼNVIC
	
	TIM_ITConfig(TIM2, TIM_IT_ARI, ENABLE);			//ʹܼж
		
	TimeBaseInit.TIM_Prescaler = 64-1;						//64M/64=1MHZ
	TimeBaseInit.TIM_Direction = TIM_Direction_Up;			//ü
	TimeBaseInit.TIM_AutoReload = 1000; 					//1MHZ/2000=1ms
	TIM_TimeBaseInit(TIM2, &TimeBaseInit);				//ʼTIM2
	
	TIM_Cmd(TIM2, ENABLE);								//ʹTIM2
	TIM_GPIO_Driver();
}

void Advanced_Timer_Init(void)
{
	Advanced_TIMER_GPIO_Config();
	Advanced_TIMER_Mode_Config();
}


extern u32 	Isr_capture_Value;
extern u32 	Isr_capture_Value_2;
extern u8	CapIsr_Flag;
extern u8	Tim_FLAG;

int main (void)
{
	u32 capvalue;
	u32 capvalue_2;
	
	UART_Driver();
	Advanced_Timer_Init();
	General_TIMER2_Config();
	while(1)
	{	
		if(CapIsr_Flag == 1)
		{
			capvalue = Isr_capture_Value;
			capvalue_2 = Isr_capture_Value_2;
			capvalue = (u16)(capvalue & 0xFFFF);		
			capvalue_2 = (u16)(capvalue_2 & 0xFFFF);
			printf("ߵƽʱΪ:%ldus",capvalue);
			printf("͵ƽʱΪ:%ldus\r\n\r\n",capvalue_2);
			CapIsr_Flag = 0;
			Software_Delay();
		}
	}
}
#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


