/******************************************************************************
  * @Example I2C
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2024/2/28
  * @brief   ʹI2C԰eepromд벢ݣʹôϢ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ							
  * ʹø̣
  *  Ҫ蹩J9߽
  *  
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x007x.h"

void Software_Delay(u32 val)//ʱ
{
    while(val)
    {
        val--;
    }
}
/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		

*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_5, AFIO_AF_0,ENABLE);	//PD5 TX0
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_6, AFIO_AF_0,ENABLE);	//PD6 RX0
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLengthAndParity=UART_WordLengthAndParity_8D;
	UART_InitStruct.UART_StopBitLength=UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode=UART_ParityMode_Odd;
	UART_InitStruct.UART_Receiver=UART_Receiver_Enable;
	UART_InitStruct.UART_LoopbackMode=UART_LoopbackMode_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/*******************************************************************************
*Function:	UART_Driver
*Description:	UARTģ
*Input:		
*Return:		
*Others:
*******************************************************************************/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

void I2C_GPIO_Config(void)
{
	/* I2Cܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_5, AFIO_AF_0,ENABLE);	//PB5 I2C SDA
	GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_4, AFIO_AF_0,ENABLE);	//PB4 I2C SCL
}
void I2C_Driver(void)
{  
    I2C_InitTypeDef I2C_InitStruct;
    I2C_InitStruct.I2C_Acknowledge = I2C_Acknowledge_Disable;
    I2C_InitStruct.I2C_Broadcast = I2C_Broadcast_Disable;
    I2C_InitStruct.I2C_OwnAddress = 0x00;
    I2C_InitStruct.I2C_Prescaler = 640-1;
    I2C_Init(I2C,&I2C_InitStruct);   
}

/**
* @brief IICд
* @param pBufferҪд
* @param WriteAddrӻַ
* @param NumByteToWriteҪдݳ
* @retval 
*/
void I2C_EE_Write(u8* pBuffer, unsigned int WriteAddr,u16 DeviceAddr, u16 data_size)
{
	int i;
/******************ȴӻready***************/		
	I2C_GenerateEvent(I2C,I2C_Event_Start,DISABLE);
	I2C->CCR |= I2C_CCR_SI | I2C_CCR_ACK;
	I2C_Cmd(I2C,DISABLE);
	I2C_Cmd(I2C,ENABLE);
	I2C_GenerateEvent(I2C,I2C_Event_Start,ENABLE);	
	while(I2C_GetFlagStatus(I2C,I2C_FLAG_StartOk)!= SET);
	I2C_SendAddr(I2C, DeviceAddr);//ַд
	while(I2C_GetFlagStatus(I2C,I2C_FLAG_MASGetAckW)!=SET);
	I2C_SendData(I2C,WriteAddr);//Ҫдֵַ
	while(I2C_GetFlagStatus(I2C,I2C_FLAG_MDSGetAck)!=SET);
	for(i=0;i<data_size;i++)
	{
		I2C_SendData(I2C, *(pBuffer++));
		while(I2C_GetFlagStatus(I2C,I2C_FLAG_MDSGetAck) != SET);
	}
		/******************ֹͣλ***************/
	I2C_GenerateEvent(I2C,I2C_Event_Stop,ENABLE);	
}

/**
* @brief IIC
* @param pBuffer
* @param ReadAddrӻַ
* @param NumByteToReadݳ
* @retval 
*/
void I2C_EE_Read(u8* pBuffer,u16 ReadAddr, u16 DeviceAddr, u16 data_size)
{
	int i;
/******************ȴӻready***************/		
	I2C_GenerateEvent(I2C,I2C_Event_Start,ENABLE);
	while(I2C_GetFlagStatus(I2C,I2C_FLAG_StartOk)!= SET);
	I2C_SendAddr(I2C, DeviceAddr);//ַд
	while(I2C_GetFlagStatus(I2C,I2C_FLAG_MASGetAckW)!=SET);
	I2C_SendData(I2C,ReadAddr);//Ҫҳַ
	while(I2C_GetFlagStatus(I2C,I2C_FLAG_MDSGetAck)!=SET);
	I2C_GenerateEvent(I2C,I2C_Event_Stop,ENABLE);
/*********************************/		
	I2C_GenerateEvent(I2C,I2C_Event_Start,ENABLE);
	while(I2C_GetFlagStatus(I2C,I2C_FLAG_StartOk)!= SET);
	I2C_SendAddr(I2C, DeviceAddr|0x1);//ַ
	while(I2C_GetFlagStatus(I2C,I2C_FLAG_MASGetAckR)!=SET);
	I2C->CR=I2C_CR_ACK;
	for(i=0;i<data_size;i++)
	{
		if(i==(data_size-1))
		{
			I2C->CCR=I2C_CCR_ACK|I2C_CCR_SI;//NACK
			while(I2C_GetFlagStatus(I2C,I2C_FLAG_MDGSendNack) != SET);
			*pBuffer=I2C_ReceiveData(I2C);
			pBuffer++;
			break;
		}
		I2C->CCR=I2C_CCR_SI;
		while(I2C_GetFlagStatus(I2C,I2C_FLAG_MDGSendAck) != SET);
		*pBuffer=I2C_ReceiveData(I2C);
		pBuffer++;
	}
	/******************ֹͣλ***************/
	I2C_GenerateEvent(I2C,I2C_Event_Stop,ENABLE);
}

u8 arry_write[10]={0};
u8 arry_read[10]={0};
int main (void)
{
  int i=0;
	u8 addr=0x0;
	
	UART_Driver();
	I2C_GPIO_Config();
	I2C_Driver();
	for(i=0;i<sizeof(arry_write);i++)
	{
		arry_write[i]=i;
	}
	printf("start to write\r\n");
	I2C_EE_Write(arry_write, addr,0xA0, sizeof(arry_write));

	printf("start to read\r\n");
	I2C_EE_Read(arry_read,addr,0xA0,sizeof(arry_read));

	for(i=0;i<sizeof(arry_read);i++)
	{
		printf("%d	",arry_read[i]);
	}
	printf("\r\n");
	while(1);
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


