/******************************************************************************
  * @Example I2C
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2024/2/28
  * @brief   ΪI2Cӷ̡֣ϴӻһʹ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ							
  * ʹø̣
  *  1Ƚ¼ΪDEMOУӻ¼ΪӻDEMO
	*	 2SCLӻSCL̽ӣSDAӻSDA̽
	*	 3λλ۲촮Ϣ
  *  4ȷӻϵ粢1-3ȸλӻȻλ
	*	 5ݸӻӴӻ
	*	 6ͺͶȡƣڽϢ
	*	 7ظ4-6裬λӻظв
	*
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  * 
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x007x.h"


void Software_Delay(u32 val)//ʱ
{
    while(val)
    {
        val--;
    }
}
/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		

*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_5, AFIO_AF_0,ENABLE);	//PD5 TX0
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_6, AFIO_AF_0,ENABLE);	//PD6 RX0
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLengthAndParity=UART_WordLengthAndParity_8D;
	UART_InitStruct.UART_StopBitLength=UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode=UART_ParityMode_Odd;
	UART_InitStruct.UART_Receiver=UART_Receiver_Enable;
	UART_InitStruct.UART_LoopbackMode=UART_LoopbackMode_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/*******************************************************************************
*Function:	UART_Driver
*Description:	UARTģ
*Input:		
*Return:		
*Others:
*******************************************************************************/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

void I2C_GPIO_Config(void)
{
	/* I2Cܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_5, AFIO_AF_0,ENABLE);	//PB5 I2C SDA
	GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_4, AFIO_AF_0,ENABLE);	//PB4 I2C SCL
}
void I2C_Driver(void)
{  
	I2C_InitTypeDef I2C_InitStruct;
	I2C_InitStruct.I2C_Acknowledge = I2C_Acknowledge_Enable;
	I2C_InitStruct.I2C_Broadcast = I2C_Broadcast_Enable;
	I2C_InitStruct.I2C_OwnAddress = 0x00;
	I2C_InitStruct.I2C_Prescaler = 479;
	I2C_Init(I2C,&I2C_InitStruct);   
}


/**
* @brief дӻӴӻ
* @param WritepBufferҪд
* @param write_sizeҪд
* @param DeviceAddrӻַ
* @param ReadpBufferŶݵָ
* @param Read_sizeҪ
* @retval 
*/
void I2C_MasterWrite2Slaver(u8* WritepBuffer,u8 write_size,u16 DeviceAddr, u8* ReadpBuffer,u8 read_size)
{
	int i;
	I2C_Cmd(I2C,ENABLE);
	I2C_GenerateEvent(I2C,I2C_Event_Start,ENABLE);	
	while(I2C_GetFlagStatus(I2C,I2C_FLAG_StartOk)!= SET);
	I2C_SendAddr(I2C, DeviceAddr|0);//ַд
	while(I2C_GetFlagStatus(I2C,I2C_FLAG_MASGetAckW)!=SET);
	for(i=0;i<write_size;i++)
	{
		I2C_SendData(I2C, *(WritepBuffer++));
		while(I2C_GetFlagStatus(I2C,I2C_FLAG_MDSGetAck) != SET);
	}
	I2C_GenerateEvent(I2C,I2C_Event_Restart,ENABLE);	
	I2C->CCR=I2C_CCR_SI;
	while(I2C_GetFlagStatus(I2C,I2C_FLAG_ReStartOk) != SET);
	I2C_SendData(I2C, DeviceAddr|1);
	while(I2C_GetFlagStatus(I2C,I2C_FLAG_MASGetAckR) != SET);
	for(i=0;i<read_size;i++)
	{
		if(i==(read_size-1))
		{
			I2C->CCR=I2C_CCR_ACK|I2C_CCR_SI;//NACK
			while(I2C_GetFlagStatus(I2C,I2C_FLAG_MDGSendNack) != SET);
			*(ReadpBuffer++)=I2C_ReceiveData(I2C);
			break;
		}
		I2C->CCR=I2C_CCR_SI;
		while(I2C_GetFlagStatus(I2C,I2C_FLAG_MDGSendAck) != SET);
		*(ReadpBuffer++)=I2C_ReceiveData(I2C);
	}
  I2C_GenerateEvent(I2C,I2C_Event_Stop,ENABLE);		
}

u8 arry_write[5]={9,8,7,6,5};
u8 arry_read[10]={0};
int main (void)
{
  int i=0;
	
	UART_Driver();
	I2C_GPIO_Config();
	I2C_Driver();
	printf("I2C̿ʼ\r\n");
	I2C_MasterWrite2Slaver(arry_write,sizeof(arry_write),0x6<<1, arry_read,sizeof(arry_read));
	for(i=0;i<sizeof(arry_read);i++)
	{
		printf("SlaverΪ%X	\r\n",arry_read[i]);
	}
	while(1);
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


