/******************************************************************************
  * @Example I2C
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2024/2/28
  * @brief   ΪI2Cӷ̡Ĵӻ֣һʹ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ							
  * ʹø̣
  *  1Ƚ¼ΪӻDEMOУ¼ΪDEMO
	*	 2SCLӻSCL̽ӣSDAӻSDA̽
	*	 3Ӵӻλλ۲촮Ϣ
  *  4ȷӻϵ粢1-3ȸλӻȻλ
	*	 5ӻĿƣݸȡ
	*	 6ͺͶȡƣڽϢ
	*  7ӻͽպľüPT32Y003x_it.cļ
	*
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32x007x.h"


void Software_Delay(u32 val)//ʱ
{
    while(val)
    {
        val--;
    }
}
/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		

*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_5, AFIO_AF_0,ENABLE);	//PD5 TX0
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_6, AFIO_AF_0,ENABLE);	//PD6 RX0
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLengthAndParity=UART_WordLengthAndParity_8D;
	UART_InitStruct.UART_StopBitLength=UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode=UART_ParityMode_Odd;
	UART_InitStruct.UART_Receiver=UART_Receiver_Enable;
	UART_InitStruct.UART_LoopbackMode=UART_LoopbackMode_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/*******************************************************************************
*Function:	UART_Driver
*Description:	UARTģ
*Input:		
*Return:		
*Others:
*******************************************************************************/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

void I2C_GPIO_Config(void)
{
	/* I2Cܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_5, AFIO_AF_0,ENABLE);	//PB5 I2C SDA
	GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_4, AFIO_AF_0,ENABLE);	//PB4 I2C SCL
}
void I2C_Driver(void)
{  
	I2C_InitTypeDef I2C_InitStruct;
	NVIC_InitTypeDef NVIC_InitStruct;
	
	NVIC_InitStruct.NVIC_IRQChannel=I2C_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelCmd=ENABLE;
	NVIC_InitStruct.NVIC_IRQChannelPriority=0x0;
	
	NVIC_Init(&NVIC_InitStruct);
	
	I2C_InitStruct.I2C_Acknowledge = I2C_Acknowledge_Enable;
	I2C_InitStruct.I2C_Broadcast = I2C_Broadcast_Enable;
	I2C_InitStruct.I2C_OwnAddress = 0x6;
	I2C_InitStruct.I2C_Prescaler = 479;
	I2C_Init(I2C,&I2C_InitStruct);   
	
	I2C_Cmd(I2C,ENABLE);
}


u8 send_arry[10]={0x66,0x77,0x88,0x99,0xaa,0xbb,0xcc,0xdd,0xee,0xff};
u8 read_arry[10]={0};
u8 arry_p=0;
u8 arry_r=0;

/**
* @brief ӻͻ
* @param I2CxѡI2C
* @param StatValueI2C״̬Ϣ
* @retval 
*/
void I2C_SlaverTransfer(I2C_TypeDef* I2Cx, u8 StatValue)
{
	switch(StatValue)
	{
		/*SlaveַֽϣACK*/
		case I2C_FLAG_SAGSendAckW:
				I2C->CR=I2C_CR_ACK;
				I2C->CCR=I2C_CCR_SI;			
				break;
		case I2C_FLAG_SDGSendAck:
				read_arry[arry_r++]=I2C_ReceiveData(I2Cx);
				I2C->CCR=I2C_CCR_SI;
				break;
		case I2C_FLAG_SDGSendNack:
				read_arry[arry_r++]=I2C_ReceiveData(I2Cx);
				I2C->CCR=I2C_CCR_SI;
				break;	
		case I2C_FLAG_SDGGSRS:
				I2C->CCR=I2C_CCR_SI;
				break;	
		case I2C_FLAG_SAGSendAckR:
				I2Cx->CCR = I2C_CCR_SI;
				I2C_SendData(I2Cx,send_arry[arry_p++]);
				break;	
		case I2C_FLAG_SDSReadAck:
				I2C_SendData(I2C, send_arry[arry_p++]);
				break;	
		case I2C_FLAG_SDSReadNack:
				I2C->CCR=I2C_CCR_SI;
				break;	
		case I2C_FLAG_SDSSAGSRS:
				I2C->CR=I2C_CR_ACK;
				I2C->CCR=I2C_CCR_SI;		
				break;	
		case I2C_FLAG_Stop:
				printf("ֹͣ\r\n");
				I2C->CCR=I2C_CCR_SI;
				arry_p=0;
				break;			
	}
}
	


int main (void)
{
	int i=0;
	UART_Driver();
	printf("I2Cӻ̿ʼ\r\n");
	I2C_GPIO_Config();
	I2C_Driver();

	while(1)
	{
		if(arry_r!=0)
		{
			for(;i<arry_r;i++)
			{
				printf("SlaveѰַյ%x\r\n",read_arry[i]);
			}
			i=0;
			arry_r=0;
		}
	}
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


