/******************************************************************************
  * @Example SPI
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2024/2/28
  * @brief   ʹSPI԰flashоƬݶдʹôϢ
  *          
  ******************************************************************************
  * @attention	
  *	ʹø:
	* 轫蹩J9߽
  * ʹSPIͨSPIȡflashоƬϢ
  * ڲ96008λλ1λֹͣλУλ
	
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣 
  * ̼/ͻʹаıϢκ,
  * Pai-ICκֱӣ ӻ̷𺦸
  * 
  * (C) ȨPai-IC Microelectronics  
  ******************************************************************************
  *****************************************************************************/
	
	
#include "PT32x007x.h"
#include "spi_flash.h"

void Software_Delay(void)//ʱ
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		

*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_5, AFIO_AF_0,ENABLE);	//PD5 TX0
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_6, AFIO_AF_0,ENABLE);	//PD6 RX0
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLengthAndParity=UART_WordLengthAndParity_8D;
	UART_InitStruct.UART_StopBitLength=UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode=UART_ParityMode_Odd;
	UART_InitStruct.UART_Receiver=UART_Receiver_Enable;
	UART_InitStruct.UART_LoopbackMode=UART_LoopbackMode_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}


/*
ʼSPIܽ
*/

void SPI_GPIO_Config(void)
{
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_3, AFIO_AF_1,ENABLE);	//SPI_CSֹܸ
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_5, AFIO_AF_1,ENABLE);	//SPI_SCKֹܸ
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_6, AFIO_AF_1,ENABLE);	//SPI_MOSIֹܸ
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_7, AFIO_AF_1,ENABLE);	//SPI_MISOֹܸ
}

void FLASH_Init(SPI_TypeDef* SPIx)
{
  SPI_InitTypeDef SPI_InitStruct;
	/*--------------- Reset SPI init structure parameters values -----------------*/
	/* Initialize the SPI_Mode member */
	SPI_InitStruct.SPI_MasterSlaveMode = SPI_MasterSlaveMode_Master;
	/* Initialize the SPI_DataSize member */
	SPI_InitStruct.SPI_DataFrameFormat = SPI_DataFrameFormat_8b;
	/* Initialize the SPI_CPOL member */
	SPI_InitStruct.SPI_ClockPolarity = SPI_ClockPolarity_Low;
	/* Initialize the SPI_CPHA member */
	SPI_InitStruct.SPI_ClockPhase = SPI_ClockPhase_1Edge;
	/* Initialize the SPI_CSS member */
	SPI_InitStruct.SPI_CSS = SPI_CSS_SoftwareControl;
  /* Initialize the SPI_SWCS member */
	SPI_InitStruct.SPI_SoftwareControlCSS = SPI_SoftwareControlCSS_High;
	/* Initialize the SPI_Prescaler member */
	SPI_InitStruct.SPI_Prescaler = 2;
	/* Initialize the SPI_BaudRatePrescaler member */
	SPI_InitStruct.SPI_BaudRate = 20;

	SPI_Init(SPI,&SPI_InitStruct);
	SPI_Cmd(SPI,ENABLE);
}


void FLASH_ReadWrite(SPI_TypeDef* SPIx,u32 addr)
{
	SPI_Flash_SectorErase(SPI,0x0);
	SPI_Flash_ReadByte(SPI,0x0);
	SPI_Flash_WriteByte(SPI,0x0);
	SPI_Flash_ReadByte(SPI,0x0);
}

int main (void)
{
	uint32_t DeviceID;
	UART_GPIO_Config();
	UART_Mode_Config();
	printf("ڶȡflashϢ\r\n");
	SPI_GPIO_Config();
	FLASH_Init(SPI);
	Software_Delay();
	DeviceID= SPI_FLASH_ReadID(SPI);
	printf("Device ID:%X\r\n",DeviceID);
	FLASH_ReadWrite(SPI,0x000);
	while(1);
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
