/******************************************************************************
  * @Example SPI Master
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2024/2/28
  * @brief   ΪSPIͨѶ̣ϴӻ̽ʹ
  *          
  ******************************************************************************
  * @attention	
  *	ʹø:
  * ڲ96008λλ1λֹͣλУλ
	*	1ϵ󣬳SPIΪ8λ֡ӲCSźŵ
	*	2USER_KEYʹϵʾSPI Master̡
	* 3ûյӻSlaver is readyʾӻ׼
	*	4֮ûɰUSER_KEYݴ
	* 5ݴɺͺͽյͨ
	*	6ûٴΰUSER_KEYظ3-5
	* 7ϵǰҪӵMOSIMISOCSSCLKGND
	*	8ʹõоƬSWDIOܽMOSIܽͬһܽʱPC7ڲʱϿSWDIOѡñ
	*    ԶϿPC7DAPֵӣSPIͨѶ
	*
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣 
  * ̼/ͻʹаıϢκ,
  * Pai-ICκֱӣ ӻ̷𺦸
  * 
  * (C) ȨPai-IC Microelectronics  
  ******************************************************************************
  *****************************************************************************/	

#include "PT32x007x.h"

#define		KEY_PROT		GPIOC
#define		KEY_PIN	    GPIO_Pin_3

void Software_Delay(void)//ʱ
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

void Delay(u32 delay)
{
	while(delay > 0)
		delay--;
}

void KEY_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;				//һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Pin = KEY_PIN;			//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_In;//ģʽΪ
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_Up;//
	GPIO_Init(KEY_PROT, &GPIO_InitStructure);		//ÿ⺯ʼGPIO
		
  GPIO_SetBits(KEY_PROT, KEY_PIN);						//GPIO״̬
}

/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		

*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_5, AFIO_AF_0,ENABLE);	//PD5 TX0
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_6, AFIO_AF_0,ENABLE);	//PD6 RX0
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLengthAndParity=UART_WordLengthAndParity_8D;
	UART_InitStruct.UART_StopBitLength=UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode=UART_ParityMode_Odd;
	UART_InitStruct.UART_Receiver=UART_Receiver_Enable;
	UART_InitStruct.UART_LoopbackMode=UART_LoopbackMode_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/*
ʼSPIܽ
*/

void SPI_GPIO_Config(void)
{
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_3, AFIO_AF_1,ENABLE);	//SPI_CSֹܸ
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_5, AFIO_AF_1,ENABLE);	//SPI_SCKֹܸ
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_6, AFIO_AF_1,ENABLE);	//SPI_MOSIֹܸ
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_7, AFIO_AF_1,ENABLE);	//SPI_MISOֹܸ
}

void SPI_MasterInit(SPI_TypeDef* SPIx)
{
  SPI_InitTypeDef SPI_InitStruct;
	/*--------------- Reset SPI init structure parameters values -----------------*/
	/* Initialize the SPI_Mode member */
	SPI_InitStruct.SPI_MasterSlaveMode = SPI_MasterSlaveMode_Master;
	/* Initialize the SPI_DataSize member */
	SPI_InitStruct.SPI_DataFrameFormat = SPI_DataFrameFormat_8b;
	/* Initialize the SPI_CPOL member */
	SPI_InitStruct.SPI_ClockPolarity = SPI_ClockPolarity_Low;
	/* Initialize the SPI_CPHA member */
	SPI_InitStruct.SPI_ClockPhase = SPI_ClockPhase_1Edge;
	/* Initialize the SPI_CSS member */
	SPI_InitStruct.SPI_CSS = SPI_CSS_HardwareControl;
  /* Initialize the SPI_SWCS member */
	SPI_InitStruct.SPI_SoftwareControlCSS = SPI_SoftwareControlCSS_High;
	/* Initialize the SPI_Prescaler member */
	SPI_InitStruct.SPI_Prescaler = 50;
	/* Initialize the SPI_BaudRatePrescaler member */
	SPI_InitStruct.SPI_BaudRate = 20;

	SPI_Init(SPI,&SPI_InitStruct);
	SPI_Cmd(SPI,ENABLE);
}

void SPI_Master2Slaver(SPI_TypeDef* SPIx,u8 send_data[],u8 receive_data[])
{
	u8 i,j;
	//
	for(i=0;i<8;i++)
	{
	  SPI_SendData(SPIx,send_data[i]);
		while(SPI_GetFlagStatus(SPI,SPI_FLAG_TXE)!=SET);
	}
	while(!SPI_GetFlagStatus(SPIx,SPI_FLAG_RXF));	
	while(SPI_GetFlagStatus(SPIx,SPI_FLAG_BSY));	
	for(i=0;i<8;i++)
	{
	  receive_data[i]=SPI_ReceiveData(SPI);
	}	
	for(j=0;j<i;j++)
	{
		printf("͵Ϊ%hu\r\n",(unsigned short)send_data[j]);
	}	
	for(j=0;j<i;j++)
	{
		printf("յΪ%hu\r\n",(unsigned short)receive_data[j]);
	}
}

u8 send_data[8]={1,2,3,4,5,6,7,10};
u8 receive_data[8]={0};
int main (void)
{
	UART_Driver();
	KEY_Driver();
	printf("SPI Master\r\n");
	SPI_GPIO_Config();
	SPI_MasterInit(SPI);
	Software_Delay();
	while(1)
	{
		if(GPIO_ReadDataBit(KEY_PROT,KEY_PIN)==0)
		{
			Delay(5000);
			if(GPIO_ReadDataBit(KEY_PROT,KEY_PIN)==0)
			{
				SPI_Master2Slaver(SPI,send_data,receive_data);
				while(!GPIO_ReadDataBit(KEY_PROT,KEY_PIN));
			}
		}
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
