#include "PT32X007x_spi.h"

/*-ͷ*******************************/
#define W25X_WriteEnable		      0x06 
#define W25X_WriteDisable		      0x04 
#define W25X_ReadStatusReg		    0x05 
#define W25X_WriteStatusReg		    0x01 
#define W25X_ReadData			        0x03 
#define W25X_FastReadData		      0x0B 
#define W25X_FastReadDual		      0x3B 
#define W25X_PageProgram		      0x02 
#define W25X_BlockErase			      0xD8 
#define W25X_SectorErase		      0x20 
#define W25X_ChipErase			      0xC7 
#define W25X_PowerDown			      0xB9 
#define W25X_ReleasePowerDown	    0xAB 
#define W25X_DeviceID			        0xAB 
#define W25X_ManufactDeviceID   	0x90 
#define W25X_JedecDeviceID		    0x9F

void SPI_FLASH_Init(SPI_TypeDef* SPIx);
void SPI_FLASH_WriteEnable(SPI_TypeDef* SPIx);
void SPI_FLASH_WaitForWriteEnd(SPI_TypeDef* SPIx);
uint32_t SPI_FLASH_ReadID(SPI_TypeDef* SPIx);
uint8_t SPI_FLASH_SendByte(SPI_TypeDef* SPIx,uint8_t byte);
void SPI_Flash_SectorErase(SPI_TypeDef* SPIx,u32 addr);
void SPI_Flash_ReadByte(SPI_TypeDef* SPIx,u32 addr);
void SPI_Flash_WriteByte(SPI_TypeDef* SPIx,u32 addr);


