/******************************************************************************
  * @Example SPI Slaver
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2024/2/28
  * @brief   ΪSPIͨѶĴӻ̣̽ʹ
  *          
  ******************************************************************************
  * @attention	
  *	ʹø:
  * ڲ96008λλ1λֹͣλУλ
	*	1ϵ󣬳SPIΪӻ8λ֡ӲCSźŵ
	*	2ôϵʾSPI Slaver̡
	* 3֮򽫴͵дSPIfifoУдɺ󴮿Slaver is ready
	*	4ɲ3յʾϢ󣬱ʾӻ׼ɣɽݴ
	* 5ݴɺ󣬴ӻͺͽյͨ
	* 6ϵǰҪӵMOSIMISOCSSCLKGND
	*	7ʹõоƬSWDIOܽMOSIܽͬһܽʱPC7ڲʱϿSWDIOѡñ
	*    ԶϿPC7DAPֵӣSPIͨѶ
	*
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣 
  * ̼/ͻʹаıϢκ,
  * Pai-ICκֱӣ ӻ̷𺦸
  * 
  * (C) ȨPai-IC Microelectronics  
  ******************************************************************************
  *****************************************************************************/	

#include "PT32x007x.h"

void Software_Delay(void)//ʱ
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

void Delay(u32 delay)
{
	while(delay > 0)
		delay--;
}

/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		

*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_5, AFIO_AF_0,ENABLE);	//PD5 TX0
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_6, AFIO_AF_0,ENABLE);	//PD6 RX0
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLengthAndParity=UART_WordLengthAndParity_8D;
	UART_InitStruct.UART_StopBitLength=UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode=UART_ParityMode_Odd;
	UART_InitStruct.UART_Receiver=UART_Receiver_Enable;
	UART_InitStruct.UART_LoopbackMode=UART_LoopbackMode_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

void UART_Driver(void)
{                                               
	UART_GPIO_Config();
	UART_Mode_Config();
}

/*7
ʼSPIܽ
*/

void SPI_GPIO_Config(void)
{
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_3, AFIO_AF_1,ENABLE);	//SPI_CSֹܸ
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_5, AFIO_AF_1,ENABLE);	//SPI_SCKֹܸ
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_6, AFIO_AF_1,ENABLE);	//SPI_MOSIֹܸ
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_7, AFIO_AF_1,ENABLE);	//SPI_MISOֹܸ
}

void SPI_SlaverInit(SPI_TypeDef* SPIx)
{
  SPI_InitTypeDef SPI_InitStruct;
	/*--------------- Reset SPI init structure parameters values -----------------*/
	/* Initialize the SPI_Mode member */
	SPI_InitStruct.SPI_MasterSlaveMode = SPI_MasterSlaveMode_Slave;
	/* Initialize the SPI_DataSize member */
	SPI_InitStruct.SPI_DataFrameFormat = SPI_DataFrameFormat_8b;
	/* Initialize the SPI_CPOL member */
	SPI_InitStruct.SPI_ClockPolarity = SPI_ClockPolarity_Low;
	/* Initialize the SPI_CPHA member */
	SPI_InitStruct.SPI_ClockPhase = SPI_ClockPhase_1Edge;
	/* Initialize the SPI_CSS member */
	SPI_InitStruct.SPI_CSS = SPI_CSS_HardwareControl;
  /* Initialize the SPI_SWCS member */
	SPI_InitStruct.SPI_SoftwareControlCSS = SPI_SoftwareControlCSS_High;
	/* Initialize the SPI_Prescaler member */
	SPI_InitStruct.SPI_Prescaler = 50;
	/* Initialize the SPI_BaudRatePrescaler member */
	SPI_InitStruct.SPI_BaudRate = 20;

	SPI_Init(SPI,&SPI_InitStruct);
	SPI_Cmd(SPI,ENABLE);
}

u8 send_data[8]={0};
u8 receive_data[8]={0};
int main (void)
{
	u8 i=0,j=0;
	u8 temp_i,temp_j;
	for(;i<8;i++)
	{
		send_data[i]=i+10;
		receive_data[i]=0;
	}
	UART_Driver();
	printf("SPI Slaver\r\n");
	SPI_GPIO_Config();
	SPI_SlaverInit(SPI);
	Software_Delay();
	while(1)
	{
		for(i=0;i<8;i++)
		{
			SPI_SendData(SPI,send_data[i]);
		}
		while(SPI_GetFlagStatus(SPI,SPI_FLAG_TNF)==SET);
		printf("Slaver is ready\r\n");
		
		while(SPI_GetFlagStatus(SPI,SPI_FLAG_RXF)!=SET);
		for(j=0;j<8;j++)
		{
			receive_data[j]=SPI_ReceiveData(SPI);
		}

		if(i==8)
		{
			temp_i=i;
			for(temp_i=0;temp_i<8;temp_i++)
			{

				printf("͵Ϊ%hu\r\n",(unsigned short)send_data[temp_i]);
			}
			i=0;
		}
		if(j==8)
		{
			temp_j=j;
			for(temp_j=0;temp_j<8;temp_j++)
			{
				printf("յΪ%hu\r\n",(unsigned short)receive_data[temp_j]);
			}
			j=0;
		}
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
