/**
  ******************************************************************************
  * @file    system_PT32X007x.c
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2024/2/28
  * @brief   
  ******************************************************************************
  * @attention
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣 
  * ̼/ͻʹаıϢκ,
  * Pai-ICκֱӣ ӻ̷𺦸
  * 
  * (C) ȨPai-IC Microelectronics  
  ******************************************************************************
  */


/* Includes ------------------------------------------------------------------*/
#include "PT32x007x.h"


/** @addtogroup PT32x007x_StdPeriph_Driver
  * @{
  */


/** @addtogroup CLK
  * @{
  */


/** @defgroup CLK_Private_Defines
  * @{
  */

/**
  * @}
  */
void Wait_ClockReady(void)
{
	u8 i,j;
	for(i=0; i<100; i++)
		for(j=0; j<48; j++);
}



//<<< Use Configuration Wizard in Context Menu >>>
/*--------------------- Clock Configuration ----------------------------------
//    <h> ϵͳʱ(SYSCLK)
//      <o0>  AHBƵ
//                <0=> 1
//                <1=> 2
//                <2=> 3
//                <3=> 4
//                <4=> 5
//                <5=> 6
//                <6=> 7
//                <7=> 8
//                <8=> 9
//                <9=> 10
//                <10=> 11
//                <11=> 12
//                <12=> 13
//                <13=> 14
//                <14=> 15
//                <15=> 16
//                <16=> 17
//                <17=> 18
//                <18=> 19
//                <19=> 20
//                <20=> 21
//                <21=> 22
//                <22=> 23
//                <23=> 24
//                <24=> 25
//                <25=> 26
//                <26=> 27
//                <27=> 28
//                <28=> 29
//                <29=> 30
//                <30=> 31
//                <31=> 32
//                <i> ĬϷƵ = 1
//      <o1>    APBƵ
//                <0=> 1
//                <1=> 2
//                <2=> 3
//                <3=> 4
//                <4=> 5
//                <5=> 6
//                <6=> 7
//                <7=> 8
//                <8=> 9
//                <9=> 10
//                <10=> 11
//                <11=> 12
//                <12=> 13
//                <13=> 14
//                <14=> 15
//                <15=> 16
//                <16=> 17
//                <17=> 18
//                <18=> 19
//                <19=> 20
//                <20=> 21
//                <21=> 22
//                <22=> 23
//                <23=> 24
//                <24=> 25
//                <25=> 26
//                <26=> 27
//                <27=> 28
//                <28=> 29
//                <29=> 30
//                <30=> 31
//                <31=> 32
//                <i> ĬϷƵ= 1
//    </h>
//
//
//    <h>  MCO
//      <e2>    MCOʹ
//                <i> Ĭ = DISABLE 
//        <o3>   MCOʱ
//                <0=> ϵͳʱ
//                <1=> LSIʱ
//        <o4>   MCOƵ
//                <0=> 1
//                <1=> 2
//                <2=> 4
//                <3=> 8
//                <4=> 16
//    </e>
//    </h>
//    <h> IFMC 
//      <o5>   Flash ȴ
//                <0=> 0 wait cycle
//                <1=> 1 wait cycle
//                <2=> 2 wait cycle
//                <i> 32MHz < fHCLK 64MHz ʱWAIT 뱻Ϊ1 ڵȴ
//    </h>
*/


/** @defgroup CLK_Private_Defines
  * @{
  */                 
#define AHB_Prescaler	  (0)    /*!< 0: DIV1,       1: DIV1,    2: DIV1,    ......      31: DIV1  */ 
#define APB_Prescaler	  (0)     /*!< 0: DIV1,       1: DIV1,    2: DIV1,    ......      31: DIV1  */ 
#define MCO_ENABLE	    (0)     /*!< 0: DISABLE,    1: ENABLE                                     */
#define MCO_SourceSEL   (1)     /*!< 0: SYSCLK 1: LSI */
#define MCO_prescale	  (0)     /*!< 0: DIV1,       1: DIV2,    2: DIV4,    3: DIV8,    4: DIV16  */
#define WaitCycle       (2)     /*!< 0:0 wait cycle,     2 wait cycle,       3 wait cycle */

/**
  * @}
  */


/** @defgroup CLK_Private_Functions
  * @{
  */
void CLOCK_SystemClockConfig(void)
{   
  RCC_HCLKSetPrescaler(AHB_Prescaler);	//HCLKƵѡ
	RCC_PCLKSetPrescaler(APB_Prescaler);	//PCLKƵѡ
}


/**
* @brief ϵͳʱ
* @param MCO_ENABLE	ָ,ϵͳʱʹ
* @param MCO_DIV		ϵͳʱķƵ
* @retval None
*/
void CLOCK_MCOConfig(void)
{   
    #if (MCO_ENABLE == 1)
	  GPIO_DigitalRemapConfig(AFIOC,GPIO_Pin_4,AFIO_AF_0,ENABLE);
		
		#if (MCO_SourceSEL == 1 )
				RCC_SetMCOSource(RCC_ClockOutput_LSI);
	  #else
				RCC_SetMCOSource(RCC_ClockOutput_HSI);
		#endif		
			RCC_MCOSetPrescaler(MCO_prescale);
    #endif                                                 
}
/**
* @brief ȡϵͳʱ
* @param none
* @retval None
*/
u32 CLOCK_GetSYSCLK(void)
{
	u32 SystemCoreClock;
	SystemCoreClock=RCC_Freq_HSI;
	return SystemCoreClock;
}

void IFMC_WaitCycle(void)
{
	if(WaitCycle==0)
	{		
	  IFMC_SetLatency(IFMC_Latency_0);
	}
	else if(WaitCycle==1)
	{
		IFMC_SetLatency(IFMC_Latency_1);
	}
	else
		IFMC_SetLatency(IFMC_Latency_2);
}

/**
* @brief IFMCȡָ
* @param None
* @retval None
*/
void IFMC_Config(void)
{
	u32 tmpdiv=0; 
	float tmprem=0;
	IFMC_WaitCycle();
	tmpdiv = (RCC_GetClockFreq(RCC_HCLK)/1000000);
	tmprem = (RCC_GetClockFreq(RCC_HCLK)%1000000);
	if(tmprem!=0)
	{
		IFMC_SetPrescaler(tmpdiv+1);		
	}
	else
	{
		IFMC_SetPrescaler(tmpdiv);
	}

}

/**
* @brief ϵͳʱӳʼ
* @param none
* @retval None
*/
void SystemInit (void)
{    
  CLOCK_SystemClockConfig();
	/* ϵͳʱ */
	CLOCK_MCOConfig();
	IFMC_Config();
}

//<<< end of configuration section >>>

/**
  * @}
  */


/**
  * @}
  */


/**
  * @}
  */


/******************* (C) Ȩ Pai-IC Microelectronics *****END OF FILE****/

